<?xml version="1.0" encoding="iso-8859-1" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>Git - StGit Crash Course</title>
	<meta name="description" content="StGit crash course tutorial" />
	<meta name="author" content="Petr Baudis" />
	<meta http-equiv="reply-to" content="pasky@suse.cz" />
	<meta http-equiv="content-language" content="en" />
	<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
	<link type="text/css" rel="stylesheet" media="screen" href="../stylesheets/screen.css" />
	<link type="text/css" title="Default" rel="stylesheet" media="screen" href="../stylesheets/screen-default.css" />
	<link type="text/css" title="Gitweb Gray" rel="alternate stylesheet" media="screen" href="../stylesheets/screen-gitweb-gray.css" />
	<link type="text/css" title="Blue" rel="alternate stylesheet" media="screen" href="../stylesheets/screen-blue.css" />
	<link type="text/css" title="Green" rel="alternate stylesheet" media="screen" href="../stylesheets/screen-green.css" />
	<link rel="icon" href="favicon.png" type="image/png" />
</head>

<body>

<table border="1" summary="Navigation links" class="header" width="100%"><tr><td>
	<a href="../index.html" id="top"><img src="../git-logo.png" width="72" height="27" alt="Git"
		style="border-width:0px;"/></a>
	<span class="hide">:</span>
	<span class="menu">
		<a href="../index.html">Home</a> |
		<a href="http://www.kernel.org/pub/software/scm/git/docs/">Documentation</a> |
		<a href="http://git.or.cz/gitwiki">Wiki</a> |
		<a href="http://www.kernel.org/pub/software/scm/git/">Download Site</a> |
		<a href="http://git.kernel.org/?p=git/git.git;a=summary">Git's Gitweb</a>
	</span>
</td></tr></table>

<h1>StGit Crash Course</h1>

<p>This tutorial should get you started with the StGit tool, which
is intended for conveniently maintaining a patch series on top of
a Git repository. You can reorder, push and pop patches, merge them
together and mail them out individually or as a patch series.</p>

<p>It is assumed that you know basics of Git at this
point, but you can actually get around by just knowing how to clone
the repository and add/remove files from the working copy:</p>

<pre>
  git clone <em>url</em>
  git add <em>file</em>
  git rm <em>file</em></td>
</pre>

<p>Before running any command the first time, it's recommended that you
at least quickly skim through its manual page. Many of the commands have
very useful and interesting features (that we won't list here) and sometimes
there are some extra notes you might want to know. There's a quick usage
help available for the StGit command using <code class="g">stg help <em>command</em></code>.</p>

<p>To initialize StGit on the current branch of your (probably
freshly cloned) repository, <code class="g">stg init</code>.</p>

<p>To add a new patch to your patch stack, do:</p>

<pre>
stg new invent-some-patch-id
<em>...edit patch description...</em>
<em>...hack hack hack in the tree...</em>
stg refresh
<em>...possibly hack some more...</em>
stg refresh
</pre>

<p>There you go. You can add several patches this way, then use
<code class="g">stg series</code> to list them - the patches
with minus sign are not applied, the patches with plus sign
are applied. You can <em>pop</em> the latest applied patch
using <code class="g">stg pop</code> and apply any of the
yet unapplied patches using <code class="g">stg push</code>.
At any point you can edit the current tree to update your
top currently updated patch - use the refresh command to
record your changes (use <code>-e</code> to update the patch
description as well). <code class="g">stg show</code> will
show the current (or any) patch.</p>

<p>If you want to update your patches to be against the latest
version of a remote branch, use the <code class="g">stg pull</code>
command. It will essentially merely pop all the patches, then update your current
branch (which probably has no local changes by then) to the upstream
revision using <code class="g">git pull</code>, then push your patches back on top of the new base.
Conflicts may occur - then you need to resolve them and tell
StGit using the <code class="g">stg resolved</code> command
(you may find the <code>-a</code> flag useful) and then update
the patch using <code>stg refresh</code> and resume the patches
pushing by doing <code>stg push -a</code>.

<p>To submit your patches using email, use the <code class="g">stg mail</code>
command. It is very powerful and can submit individual patches,
arbitrary patch series or your whole stack, send covermails and
make your patches followups of other mails. You will probably
want to create simple email templates for your patch. You can
find all the details in the <code class="g">stg help mail</code>
output.</p>

<p>If you have any question or problem which is not obvious from
the documentation, please contact us at the <strong>Git mailing list</strong>
at <a href="mailto:git@vger.kernel.org">git@vger.kernel.org</a>.
We hope you enjoy using Git!</p>



<hr />

<div class="footer">
	<span class="menu">
		This page is maintained by Petr Baudis. Please email me
		at <a href="mailto:pasky@suse.cz">pasky@suse.cz</a>
		with patches, suggestions and comments.
	</span>
</div>

</body>
</html>
